import { ThrusterSet } from '../../lab/engine2D/ThrusterSet.js';
import { Vector } from '../../lab/util/Vector.js';
import { Util } from '../../lab/util/Util.js';
export class SixThrusters {
    constructor() {
        throw '';
    }
    ;
    static make(magnitude, body) {
        const ts = new ThrusterSet(6, body, magnitude);
        for (let i = 0; i < 6; i++) {
            ts.setThruster(i, SixThrusters.getLocationBody(i, body), SixThrusters.getDirectionBody(i));
        }
        return ts;
    }
    ;
    static getLocationBody(index, body) {
        const t_body = body.getDragPoints()[0];
        if (index <= 2) {
            return t_body;
        }
        const centroid_body = body.getCentroidBody();
        const diff = t_body.subtract(centroid_body);
        return centroid_body.subtract(diff);
    }
    ;
    static getDirectionBody(index) {
        if (index < 0 || index >= SixThrusters.thrustAngle.length) {
            return Vector.ORIGIN;
        }
        const tmag = (index == 2 || index == 3) ? 1.0 : 0.4;
        return new Vector(tmag, 0).rotate(SixThrusters.thrustAngle[index]);
    }
    ;
}
SixThrusters.thrustAngle = [Math.PI, 0, Math.PI / 2, -Math.PI / 2, Math.PI, 0];
Util.defineGlobal('sims$engine2D$SixThrusters', SixThrusters);
