import { Util } from '../../lab/util/Util.js';
import { AbstractPath } from './AbstractPath.js';
export class LemniscatePath extends AbstractPath {
    constructor(size, start, finish, closedLoop, name, localName) {
        if (typeof start !== 'number')
            start = -Math.PI / 4;
        if (typeof finish !== 'number')
            finish = 3 * Math.PI / 4;
        if (closedLoop === undefined)
            closedLoop = true;
        name = name || LemniscatePath.en.NAME;
        localName = localName || LemniscatePath.i18n.NAME;
        super(name, localName, start, finish, closedLoop);
        this.a_ = size;
    }
    ;
    toString() {
        return super.toString().slice(0, -1)
            + ', size: ' + Util.NF(this.a_) + '}';
    }
    ;
    getClassName() {
        return 'LemniscatePath';
    }
    ;
    x_func(t) {
        if (t <= Math.PI / 4) {
            return this.a_ * Math.sqrt(2 * Math.cos(2 * t)) * Math.cos(t);
        }
        else if (t <= 3 * Math.PI / 4) {
            const T = -t + Math.PI / 2;
            return -this.a_ * Math.sqrt(2 * Math.cos(2 * T)) * Math.cos(T);
        }
        else {
            return 0;
        }
    }
    ;
    y_func(t) {
        if (t <= Math.PI / 4) {
            return this.a_ * Math.sqrt(2 * Math.cos(2 * t)) * Math.sin(t);
        }
        else if (t <= 3 * Math.PI / 4) {
            const T = -t + Math.PI / 2;
            return -this.a_ * Math.sqrt(2 * Math.cos(2 * T)) * Math.sin(T);
        }
        else {
            return 0;
        }
    }
    ;
}
LemniscatePath.en = {
    NAME: 'Lemniscate'
};
LemniscatePath.de_strings = {
    NAME: 'Lemniscate'
};
LemniscatePath.i18n = Util.LOCALE === 'de' ? LemniscatePath.de_strings : LemniscatePath.en;
Util.defineGlobal('sims$roller$LemniscatePath', LemniscatePath);
