import { Util } from '../../lab/util/Util.js';
import { AbstractPath } from './AbstractPath.js';
export class SpiralPath extends AbstractPath {
    constructor() {
        super(SpiralPath.en.NAME, SpiralPath.i18n.NAME, 0, 0, true);
        this.arc1x = -2.50287;
        this.arc1y = 5.67378;
        this.rad = 1;
        this.slo = 4.91318;
        this.slox = 0.122489;
        this.sloy = -0.601809;
        this.shi = 25.9566;
        this.shix = 2.20424;
        this.shiy = 2.38089;
        this.arc2y = this.sloy + this.rad;
        this.arc1rx = this.arc1x + Math.cos(Math.PI / 4);
        this.t1 = Math.PI / 2;
        this.t2 = this.t1 + this.arc1y - this.arc2y;
        this.t3 = this.t2 + Math.PI / 2;
        this.t4 = this.t3 + this.slox - this.arc1x;
        this.t5 = this.t4 + this.shi - this.slo;
        this.t6 = this.t5 + Math.sqrt(2) * (this.shix - this.arc1rx);
        this.t7 = this.t6 + Math.PI / 4;
        this.setFinishTValue(this.t7);
    }
    ;
    getClassName() {
        return 'SpiralPath';
    }
    ;
    x_func(t) {
        if (t < this.t1) {
            return Math.cos(t + Math.PI / 2) + this.arc1x;
        }
        else if (t < this.t2) {
            return this.arc1x - this.rad;
        }
        else if (t < this.t3) {
            return Math.cos(t - this.t2 + Math.PI) + this.arc1x;
        }
        else if (t < this.t4) {
            return this.arc1x + (t - this.t3);
        }
        else if (t < this.t5) {
            return ((t - this.t4 + this.slo) / 8) * Math.cos(t - this.t4 + this.slo);
        }
        else if (t < this.t6) {
            return this.shix - (t - this.t5) / Math.sqrt(2);
        }
        else if (t < this.t7) {
            return this.arc1x + Math.cos(Math.PI / 4 + t - this.t6);
        }
        else {
            return 0;
        }
    }
    ;
    y_func(t) {
        if (t < this.t1) {
            return Math.sin(t + Math.PI / 2) + this.arc1y;
        }
        else if (t < this.t2) {
            return this.arc1y - (t - this.t1);
        }
        else if (t < this.t3) {
            return Math.sin(t - this.t2 + Math.PI) + this.arc2y;
        }
        else if (t < this.t4) {
            return this.sloy;
        }
        else if (t < this.t5) {
            return ((t - this.t4 + this.slo) / 8) * Math.sin(t - this.t4 + this.slo);
        }
        else if (t < this.t6) {
            return this.shiy + (t - this.t5) / Math.sqrt(2);
        }
        else if (t < this.t7) {
            return this.arc1y + Math.sin(Math.PI / 4 + t - this.t6);
        }
        else {
            return 0;
        }
    }
    ;
}
SpiralPath.en = {
    NAME: 'Spiral'
};
SpiralPath.de_strings = {
    NAME: 'Spirale'
};
SpiralPath.i18n = Util.LOCALE === 'de' ? SpiralPath.de_strings : SpiralPath.en;
Util.defineGlobal('sims$roller$SpiralPath', SpiralPath);
