import { ChoiceControl } from '../lab/controls/ChoiceControl.js';
import { CircleStraightTest } from './CircleStraightTest.js';
import { CollisionAdvance } from '../lab/model/CollisionAdvance.js';
import { DoubleRect } from '../lab/util/DoubleRect.js';
import { Engine2DApp } from '../sims/engine2D/Engine2DApp.js';
import { ImpulseSim } from '../lab/engine2D/ImpulseSim.js';
import { LabelControl } from '../lab/controls/LabelControl.js';
import { RigidBodySim } from '../lab/engine2D/RigidBodySim.js';
import { Util } from '../lab/util/Util.js';
export class StuckTestApp extends Engine2DApp {
    constructor(elem_ids) {
        const simRect = new DoubleRect(-6, -6, 6, 6);
        const sim = new ImpulseSim();
        const advance = new CollisionAdvance(sim);
        super(elem_ids, simRect, sim, advance);
        this.showClockParam.setValue(true);
        this.showEnergyParam.setValue(true);
        CircleStraightTest.ball_falls_on_floor_setup(this.sim, advance);
        this.addPlaybackControls();
        this.addStandardControls();
        const ps = this.sim.getParameterString(RigidBodySim.en.COLLISION_HANDLING);
        this.addControl(new ChoiceControl(ps));
        if (Util.DEBUG) {
            this.addControl(new LabelControl('compiled ' + Util.COMPILE_TIME));
        }
        this.makeEasyScript();
        this.addURLScriptButton();
        this.graphSetup();
    }
    ;
    toString() {
        return this.toStringShort().slice(0, -1)
            + super.toString();
    }
    ;
    getClassName() {
        return 'StuckTestApp';
    }
    ;
}
Util.defineGlobal('test$StuckTestApp', StuckTestApp);
